<template>
  <button
    @click.stop.prevent="handleClick"
    v-if="hasProduct"
  >
    В корзине
  </button>

  <button
    v-else
    @click.stop.prevent="handleClick"
  >
    В корзину
  </button>
</template>

<script setup lang="ts">
  import type { PropType } from 'vue'
  import type { MenuProduct } from '~/composable/restaurant/useRestaurantMenu'
  import { useBasket } from '~/composable/useBasket'
  import { useUserAuth } from '~~/composable/user/useUserAuth'
  import { useTypedRouter } from '~~/generated'

  const props = defineProps({
    product: {
      type: Object as PropType<MenuProduct>,
      required: true
    }
  })

  const {router, routes} = useTypedRouter()
  const {user} = useUserAuth()
  const {checkHasProduct, addToBasket, openBasket} = useBasket()

  const hasProduct = computed(() => checkHasProduct.value(props.product.id))
  const handleClick = () => {
    if (!user.value) {
      router.push({ name: routes.signin })
    } else if (hasProduct.value) {
      openBasket()
    } else {
      addToBasket(props.product)
    }
  }

</script>